;----------------------------------------------------------------------------
;
; MV szignl digitlis (NMRA DCC) modellvasthoz
;
; www.tfd.hu - tfd@tfd.hu
;
;----------------------------------------------------------------------------



	processor	16f84a
	include		"p16f84a.inc"

	__config	_HS_OSC & _WDT_OFF & _PWRTE_OFF & _CP_OFF

	radix		dec


;------	Konstansok

SADR	equ	99		;a dekder cme

;------	Portok

#define DCCIN   PORTA,4
				;bejv DCC stream


;------	RAM


RAMBASE	equ	0ch             ;RAM bziscm


BITLNG	equ	RAMBASE         ;bitid mr
#define PREVIN	RAMBASE+1,0
				;bejv DCC jel elz ismert llapota
DCSTATE	equ	RAMBASE+2	;dekdols llapota
				;als 4 bit a bitszmll
#define	DCCBIT	DCSTATE,4
				;hossza alapjn dekdolt DCC bit
#define	PREAMB	DCSTATE,5
				;0: preamble - 1: adatbitek
ERRDET	equ	RAMBASE+3	;error detection byte
PACKET	equ	RAMBASE+4	;vett DCC csomag trolhelye

VGRBASE	equ	RAMBASE+14      ;hanggenertor RAM bzis


;------	Program

	org	0

	call	VGINIT		;hanggenertor kimenetek belltsa

	bsf	STATUS,RP0	;page 1
	movlw	11111111b       ;adatirnyok
        movwf   PORTA
        movwf   PORTB
	call	VGINIT          ;hanggenrtor kimenetek aktvak

	bcf	STATUS,RP0	;page 0







	clrf	BITLNG		;nincs vals hosszsg bit

	movlw	05h		;dekdols alapllapota
        movwf   DCSTATE

	bsf	PREVIN          ;bejv jel llapota
	btfss	DCCIN
	bcf	PREVIN



LOOP


;bit rtk megllapts

	btfss	DCCIN		;bit magas?
	goto	bitl

	bsf	PREVIN		;troljuk

binov	incfsz	BITLNG,f        ;hossza nvekszik, de ha tlcsordulna,
	goto	BW11
	decf	BITLNG,f	;akkor vissza 255-re
	goto	BW13


bitl	btfss	PREVIN		;elzleg magas volt?
	goto	prevl

	bcf	PREVIN		;troljuk, hogy alacsony lett

	goto	binov		;de az idmrs mg nem szakad meg!
				;mobil dekdernl zavarszr hatsa lehet

prevl	movf	BITLNG,f	;bit hossza 0?
	btfsc	STATUS,Z
	goto	BW10		;akkor nem vals bit

	bcf	DCCBIT		;felttelezzk, hogy a bit alacsony
	movlw	11              ;a hossza alapjn
	subwf	BITLNG,w
	btfss	STATUS,C
	bsf	DCCBIT		;mgis magas

        clrf    BITLNG          ;legkzelebb idmrs indul

	;15

;stream dekdols

	movf	DCSTATE,w	;llapotbl
	addwf	PCL,f		;szmtott ugrs

				;PREAMB=0 DCCBIT=0

	nop			;00
	nop			;01
	nop			;02
	nop			;03
	nop			;04
	goto	PA0		;05 - preamble 0 bittel megszakad
	goto	PA0		;06 - preamble 0 bittel megszakad
	goto	PA0		;07 - preamble 0 bittel megszakad
	goto	PA0		;08 - preamble 0 bittel megszakad
	goto	PA0		;09 - preamble 0 bittel megszakad
	goto	PA0		;0a - preamble 0 bittel megszakad
	goto	PA0		;0b - preamble 0 bittel megszakad
	goto	PA0		;0c - preamble 0 bittel megszakad
	goto	PA0		;0d - preamble 0 bittel megszakad
	goto	PA0		;0e - preamble 0 bittel megszakad
	goto	PSBIT		;0f - packet start bit

				;PREAMB=0 DCCBIT=1

	nop			;10
	nop			;11
	nop			;12
	nop			;13
	nop			;14
	goto	PA1		;15 - 1. preamble bit
	goto	PA1		;16 - 2. preamble bit
	goto	PA1		;17 - 3. preamble bit
	goto	PA1		;18 - 4. preamble bit
	goto	PA1		;19 - 5. preamble bit
	goto	PA1		;1a - 6. preamble bit
	goto	PA1		;1b - 7. preamble bit
	goto	PA1		;1c - 8. preamble bit
	goto	PA1		;1d - 9. preamble bit
	goto	PA1		;1e - 10. preamble bit
	goto	PA1_11		;1f - 11. vagy tbb preamble bit

				;PREAMB=1 DCCBIT=0

	nop			;20
	nop			;21
	nop			;22
	nop			;23
	nop			;24
	nop			;25
	nop			;26
	goto	DATA0		;27 - 7. adatbit = 0
	goto	DATA0		;28 - 6. adatbit = 0
	goto	DATA0		;29 - 5. adatbit = 0
	goto	DATA0		;2a - 4. adatbit = 0
	goto	DATA0		;2b - 3. adatbit = 0
	goto	DATA0		;2c - 2. adatbit = 0
	goto	DATA0		;2d - 1. adatbit = 0
	goto	DATA0		;2e - 0. adatbit = 0
	goto	BSBIT		;2f - byte start bit

				;PREAMB=1 DCCBIT=1

	nop			;30
	nop			;31
	nop			;32
	nop			;33
	nop			;34
	nop			;35
	nop			;36
	goto	DATA1		;37 - 7. adatbit = 1
	goto	DATA1		;38 - 6. adatbit = 1
	goto	DATA1		;39 - 5. adatbit = 1
	goto	DATA1		;3a - 4. adatbit = 1
	goto	DATA1		;3b - 3. adatbit = 1
	goto	DATA1		;3c - 2. adatbit = 1
	goto	DATA1		;3d - 1. adatbit = 1
	goto	DATA1		;3e - 0. adatbit = 1
	goto	PEBIT		;3f - packet end bit
;       ^Ez az ugrs feleselges, 2 ciklus sprols a kihagysa!
;        Fontos, mert ez a leghosszabb futsi idej g!

;Packet End BIT

PEBIT	movlw	06h		;ez a bit beleszmolhat
	movwf	DCSTATE		;a kvetkez preamble-ba
	movf	INDF,w		;csomag hibtlan?
	xorwf	ERRDET,f
	btfss	STATUS,Z
	goto	WRONGP		;nem

	;6
	;itt lehet a csomagot feldolgozni

	movlw	SADR		;cm?
	subwf	PACKET,w
	btfss	STATUS,Z
	goto	njcim		;nem neknk szl

	movf	PACKET+1,w	;parancs
	andlw	11100001b	;(neknk most) hasznos bitek
	sublw	10000001b	;F1 bekapcsolva?
	btfsc	STATUS,Z

	call	VGEN		;akkor jn a muzsika
	;itt most elvesztette a DCC fonalt,
	;de amint lehet jraszinkronizl...

	goto	LOOP


njcim	nop
	nop
	nop
	nop
	nop
	nop

	goto	LOOP



;PreAmble bit 0


PA0	movlw	05h		;nem volt elg preamble bit, ezrt
	movwf	DCSTATE		;kezdjk ellrl a szmolst

	goto	WAIT4



;Packet Start BIT

PSBIT	movlw	27h		;7. adatbit fog kvetkezni
	movwf	DCSTATE

	movlw	PACKET		;csomag eleje
	movwf	FSR

	clrf	ERRDET		;hiba vizsgl byte alaprtk

	goto	WAIT7






;Byte Start BIT

BSBIT	movf	INDF,w		;elzleg vett byte-tal
	xorwf	ERRDET,f	;a hiba vizsgl byte vltozik

	movlw	27h		;7. adatbit fog kvetkezni
	movwf	DCSTATE

	incf	FSR,f		;a csomag kvetkez byte-jban

	goto	WAIT7



;PreAmble bit 1

PA1	incf	DCSTATE,f	;kvetkez preamble bit fog jnni
	goto	WAIT3





DATA0	rlf	INDF,f
	bcf	INDF,0
	incf	DCSTATE,f

	goto	WAIT5




DATA1	rlf	INDF,f
	bsf	INDF,0
	incf	DCSTATE,f

	goto	WAIT5


;fizikai jel feldolgozs idzts hangolsok


BW10	nop
BW11	nop
	nop
BW13	nop
	nop

	;15 ciklus a bit megllapts

;stream feldolgozs idzts hangolsok

	nop		;szmtott ugrs ideje
	nop
	nop
	nop
	nop


PA1_11	nop
	nop
	nop
WAIT3	nop
WAIT4	nop
WAIT5	nop
	nop

WAIT7
WRONGP

	;27 ciklus a csomag megszerzse, fizikai rsszel egytt

;csomag feldolgozsnyi vrakozs


	nop			;legyen mondjuk 10 ciklus
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	goto	LOOP




;------------------------------------------------
; Hanggenertor
;------------------------------------------------
;
;
;


;------ Portok

#define	CH1OUT	PORTB,0
				;1. csatorna kimenet
#define	CH2OUT	PORTB,1
				;2. csatorna kimenet

;------ RAM - 13 byte


NOTECNT	equ	VGRBASE		;tem szmll
MPTR	equ	VGRBASE+1	;zene tbla pointer
NTMRH	equ	VGRBASE+2	;hang hossz idzt
NTMRL	equ	VGRBASE+3
PA1H	equ	VGRBASE+4	;1. csatorna fzis akkumultor
PA1L	equ	VGRBASE+5
PA2H	equ	VGRBASE+6	;2. csatorna fzis akkumultor
PA2L	equ	VGRBASE+7
CH1H	equ	VGRBASE+8	;1. csatorna nvekmny
CH1L	equ	VGRBASE+9
CH2H	equ	VGRBASE+10      ;2. csatorna nvekmny
CH2L	equ	VGRBASE+11
LTTMR	equ	VGRBASE+12      ;futsid klnbsg idzt


;------ Program

	org	200h

VGINIT	bcf	CH1OUT          ;adatirny kimentre llts (RP0=1)
	bcf	CH2OUT		;s kimenetek trlse (RP=0)
	return


VGEN	bsf	PCLATH,1	;200h lap bellts a tblzathoz

	clrf	PA1L		;fzis akkumultorok trlse
	clrf	PA1H
	clrf	PA2L
	clrf	PA2H

	clrf	MPTR		;zene elejn kezdnk

	movlw	11		;11 tem hossz a nta
	movwf	NOTECNT

newnote	movf	MPTR,w		;a tblzatbl
	incf	MPTR,f
	call	MUSIC
	movwf	CH1H		;1. csatorna nvekmny high byte
	movf	MPTR,w		;a tblzatbl
	incf	MPTR,f
	call	MUSIC
	movwf	CH1L		;1. csatorna nvekmny low byte

	iorwf	CH1H,w		;ha a nvekmny=0,
	btfsc	STATUS,Z
	clrf	PA1H		;akkor a kimenet is majd 0 legyen

	movf	MPTR,w		;a tblzatbl
	incf	MPTR,f
	call	MUSIC
	movwf	CH2H		;2. csatorna nvekmny high byte
	movf	MPTR,w		;a tblzatbl
	incf	MPTR,f
	call	MUSIC
	movwf	CH2L		;2. csatorna nvekmny low byte

	iorwf	CH2H,w		;ha nvekmny=0,
	btfsc	STATUS,Z
	clrf	PA2H		;akkor a kimenet is majd 0 legyen

	movlw	40		;hangok hossza
	movwf	NTMRH
	movlw	0
	movwf	NTMRL

vgloop	nop
	nop
	nop
	nop

	movf	CH1L,w		;1. csatorna nvekmny low byte
	addwf	PA1L,f		;fzis akkumultor low byte-jhoz hozzadjuk
	btfsc	STATUS,C	;tlcsorduls?
	incf	PA1H,f		;akkor high byte is nvekszik
	movf	CH1H,w		;nvekmny high byte
	addwf	PA1H,f		;fzis akkumultor high byte-jhoz hozzadjuk

	movf	CH2L,w		;2. csatorna nvekmny low byte
	addwf	PA2L,f		;fzis akkumultor low byte-jhoz hozzadjuk
	btfsc	STATUS,C	;tlcsorduls?
	incf	PA2H,f		;akkor high byte is nvekszik
	movf	CH2H,w		;nvekmny high byte
	addwf	PA2H,f		;fzis akkumultor high byte-jhoz hozzadjuk



	btfsc	PA1H,7		;1. csatorna fzis akkumultor fels bit
	goto	ch11		;kimsols a kimenetre
	bcf	CH1OUT
	goto	ch10v
ch11	bsf	CH1OUT
	nop

ch10v	btfsc	PA2H,7		;2. csatorna fzis akkumultor fels bit
	goto	ch21		;kimsols a kimenetre
	bcf	CH2OUT
	goto	ch20v
ch21	bsf	CH2OUT
	nop

ch20v	decfsz	NTMRL,f		;ha a hang ideje nem jrt le,
	goto	vgl2
	decfsz	NTMRH,f
vgl2	goto	vgloop2		;akkor egy kis idztsi kitr utn vgloop

	decfsz	NOTECNT,f	;ha van mg,
	goto	newnote		;akkor kvetkez tem hangjai

	bcf	CH1OUT		;klnben kimenetek kikapcsolsa
	bcf	CH2OUT

	bcf	PCLATH,1	;lap visszallts

	return			;s vge


vgloop2	nop

	movlw	15		;ciklus=6+(X-1)*3
	movwf	LTTMR
lido	decfsz	LTTMR,f
	goto	lido
	goto	vgloop




;egy hangmagassgot meghatroz word kiszmtsa:
;tw=(fhang*65536)/(fosc/320)
;termszetesen a kapott rtket egszre kell kerekteni
;
;pl. az els hangnl ami 1175Hz
;(1175*65536)/(20000000/320)=1232.0768 -> 04d0h
;
;0 rtk az adott csatornt kikapcsolja
;

MUSIC	addwf	PCL,f

	retlw	004h		;CH1H
	retlw	0d0h		;CH1L
	retlw	000h		;CH2H
	retlw	000h		;CH2L

	retlw	004h
	retlw	0d0h
	retlw	000h
	retlw	000h

	retlw	003h
	retlw	09bh
	retlw	000h
	retlw	000h

	retlw	004h
	retlw	00bh
	retlw	000h
	retlw	000h

	retlw	003h
	retlw	09bh
	retlw	000h
	retlw	000h

	retlw	003h
	retlw	09bh
	retlw	000h
	retlw	000h

	retlw	003h
	retlw	008h
	retlw	004h
	retlw	0d0h

	retlw	003h
	retlw	036h
	retlw	004h
	retlw	0d0h

	retlw	003h
	retlw	008h
	retlw	003h
	retlw	09bh

	retlw	003h
	retlw	008h
	retlw	003h
	retlw	09bh

	retlw	003h
	retlw	008h
	retlw	003h
	retlw	09bh



        end

